package org.zeroturnaround.javarebel.wicket;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class InjectorCBP extends JavassistClassBytecodeProcessor {
	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
			throws Exception {

		cp.importPackage("org.zeroturnaround.javarebel");
		cp.importPackage("java.util");

		CtClass reloadListener = cp
				.get("org.zeroturnaround.javarebel.ClassEventListener");

		ctClass.addInterface(reloadListener);

		CtMethod m = CtNewMethod.make("public void onClassEvent(int eventType, Class klass) {\n"
				+ "Iterator it = classToFields.keySet().iterator();\n"
				+ "  while(it.hasNext()) {\n"
				+ "    if (klass.isAssignableFrom((Class)it.next())) {\n"
				+ "      it.remove();\n" + " }\n" + " } \n" + "}\n", ctClass);
		ctClass.addMethod(m);
		
    CtMethod m2 = CtNewMethod.make("int priority() {" +
    		" return PRIORITY_WEB - 777;" +
    		"}", ctClass);
    ctClass.addMethod(m2);

	}
}
