package org.zeroturnaround.javarebel.wicket;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class SpringBeanLocatorCBP extends JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
			throws Exception {
		
	  cp.importPackage("org.springframework.context");
		cp.importPackage("org.springframework.context.support");
		
    CtMethod m = CtNewMethod
        .make(
            " private void refreshApplicationContext() {\n"
                + " ApplicationContext context = getSpringContext(); \n"
                + " if (context instanceof AbstractRefreshableApplicationContext) {"
                + "     ((AbstractRefreshableApplicationContext)context).refresh();"
                + " }" + " }", ctClass);
    ctClass.addMethod(m);
		
		CtMethod m0 = ctClass.getDeclaredMethod("isSingletonBean");
		m0
				.setBody("{"
						+ "if (singletonCache == null) {"
						+ " try {"
						+ "   singletonCache = Boolean.valueOf(getSpringContext().isSingleton(getBeanName()));"
						+ " } catch (Exception e) {"
						+ "   refreshApplicationContext();"
						+ "   singletonCache = Boolean.valueOf(getSpringContext().isSingleton(getBeanName()));"
						+ " }\n" + "}"
						+ "return singletonCache.booleanValue();" + "}");

		CtMethod m1 = ctClass.getDeclaredMethod("locateProxyTarget");
		m1
				.setBody("{"
						+ "final ApplicationContext context = getSpringContext();"
						+ "if (beanName != null && beanName.length() > 0)"
						+ "{"
						+ "  try {"
						+ "    return lookupSpringBean(context, beanName, getBeanType());"
						+ "  } catch (Exception e) {"
						+ "    refreshApplicationContext();"
						+ "    return lookupSpringBean(context, beanName, getBeanType());"
						+ "  }" + "}" + "else" + "{" + "try {"
						+ "    return lookupSpringBean(context, getBeanType());"
						+ "  } catch (Exception e) {"
						+ "    refreshApplicationContext();"
						+ "    return lookupSpringBean(context, getBeanType());"
						+ "}" + "}" + "	}");
	}
}
